> For the complete documentation index, see [llms.txt](https://docs.theopenpresenter.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.theopenpresenter.com/networking/host-projects.md).

# Host Projects

Host projects are a feature in TOP that allows users to access projects in local instances through an existing cloud connection.&#x20;

> To put it into picture:&#x20;
>
> * Desktop app connects to cloud & opens a project locally
> * A separate device connects to <https://theopenpresenter.com>
>   * And accesses the local project
>   * All request will be proxied through the cloud

#### How does this work?

When a desktop instance with a cloud connection is online, it will:&#x20;

1. Ping the cloud instance to notify of its existence
   1. This includes the details required for us to connect to the instance (iroh ticket)
   2. As well as the currently active projects
2. In the cloud, we show the open projects for all host projects
3. Opening it will open a project URL with specific queries
   1. We then use this queries to know how to proxy the request
      1. `pOrg` and `pEndpoint` in the URL
      2. Backend wise, we use `x-organization-slug` and `x-iroh-endpoint-id` as headers to identify that this should be proxied.
   2. An iroh endpoint is opened on the cloud, which is then used to proxy the request

> Note: When accessing a host project, the organization and project slug in the URl should be of the hosts. This is because our code reads the URL to determine what should be fetched. On the cloud, we read the search query to know how to proxy.&#x20;
>
> So this can be confusing, but practically, it looks something like this:
>
> https\://**\[cloud]**.com/**\[localRoute]**?**\[cloudProxyDetails]**


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.theopenpresenter.com/networking/host-projects.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
